
Global ScreenWidth% ;        ( )
Global ScreenHeight%
;-------------------    ------------
count%=CountGfxModes3D()

k%=0
sum%=GfxModeWidth(1)+GfxModeHeight(1)
For i%=2 To count
	If GfxModeWidth(i)+GfxModeHeight(i)>=sum And GfxModeDepth(i)=32
		sum=GfxModeWidth(i)+GfxModeHeight(i)
		k=i
	EndIf
Next
ScreenWidth=GfxModeWidth(k)
ScreenHeight=GfxModeHeight(k)


;----------      ------------

;InitGraphics(1024,768)
InitGraphics(ScreenWidth,ScreenHeight)

;--------     ------------
Global font
fontsize%=Ceil(ScreenWidth/65)
font=LoadFont ("Arial Cyr",fontsize,True,False)
SetFont font

;-------    ----------------------
Vvedenie("Media\Images\screen1.jpg")

;-------    ,----------------------------------
Const TypeWall=2 ;  
Const TypeBullet=3 ;  

;-------       -------------

Collisions TypeBullet,TypeWall,2,1



Global FPS=100  ;  FPS-   
Global period=1000/FPS
Global time=MilliSecs()-period
Global tween#;     


Global G#=9.8 ;    
Global Ugol# ;     
;Global Ugol2
Global Skorost=1000 ;    
Global Skorost2 ;    
Global Skorost3;     ()
Global MassBullet=3;  
Global MassOrudie=300 ;  
Global TimeBullet# ;   
Global TimeBullet2 ;     
Global Vysota; .   
Global Dalnost;   
;Global TimeBullet2
Global sound ;  
Global sound2;  
Global listener;   (    )
Global dym ;
Global Time_dym ;      
Global ogon ;  
Global effects=True; ,    \ 

Global logo;  Blitz3D

Global XOY; 
Global XOY2
Global ur_t;
Global ur_x_y
Global ur_vx_vy
Global ur_x_y_max
Global imgMode%=1

Global camera;  
Global camera2;  
Global isCam2=False;    
Global light;        
Global ground; - 
Global stanina;  
Global koleso;  
Global koleso2;    
Global bullet_source; ,   
Global start ;      

Global TimeEffects;  

;--------------     ---------------------
Type Bullet
	Field  bullet
	Field px#
	Field py#
	Field pz#
	Field ux#
	Field uy#
	Field uz#
	Field time#
	Field red%
	Field green%
	Field blue%
End Type
;--------------     ---------------------
Type Part
	Field alpha#
	Field part
End Type


;-------------C       
InitCameras()
;------------- :    -------------------------------
InitGround()
;-------------   -----------------------------------
InitImages()

;-------------    -------------------------------
InitOrudie()
;-------------  ----------------------------------------------
InitSound()

HidePointer 


;--------------                       -----------------------------------------------------------------------------------------------------------------------------------------------------
While Not KeyHit(1)
	;-    - 100      ""
	Repeat
		elapsed=MilliSecs()-time
	Until elapsed
		
	ticks=elapsed/period
	tween#=Float(elapsed Mod period)/Float(period)
	
	For k=1 To ticks
		time=time+period
		If k=ticks Then CaptureWorld
		
		UpdateOrudie()   ; 
		UpdateBullet()   ;  
		Podschet() ;  
		UpdateCameras() ;  
		UpdateParticles()  ;     
		
		;  10       
		If effects=True
			If MouseDown(1)=False
				Time_dym=Time_dym+1
				If Time_dym=50
					InitParticles(dym,3,5,5,start,Rnd(-10,10),Rnd(-10,10),Rnd(-3,-1),.1)
					Time_dym=0
				EndIf
			EndIf 
		EndIf
		
		UpdateWorld  ;  ""
	Next

	RenderWorld tween# ;    
	
	DrawText() ;     
	UpdateImages();   	

	Flip 1 ;     
Wend
;-------------                              ------------------------------------------------------------------------------------------------------------------------------------



;--------   --------------------
EraseAll()

;-------    ----------------------
;     
SetBuffer FrontBuffer()
Cls
Flip
SetBuffer BackBuffer()
Cls
Flip 
CameraClsColor camera,0,0,0 ;    
;   " "
Vvedenie("Media\Images\screen2.jpg")

;--------  -------------------
End
;-------------------------------------------------------------------
Function Vvedenie(name$)
	Cls;  
	SetBuffer FrontBuffer();  
	SetFont font ;    
	img=LoadImage(name$);      
	If img=0 Return;    -   
	
	width%=ImageWidth(img)
	height%=ImageHeight(img)
	x%=(ScreenWidth-width)/2
	y%=(ScreenHeight-height)/2
	While Not KeyHit(57)
		DrawImage(img,x,y);    
		Color 255,255,255;  - 
		Text 100,ScreenHeight-100,"      "
		Flip ;   
	Wend
	FreeImage img ;    
	Cls
	SetBuffer BackBuffer()
End Function

;--------------------------------------------------------
Function InitGraphics(width%,height%)
	Graphics3D width,height,32,1 ;  3D-
		;Graphics3D 1024,768,32,1
	SetBuffer BackBuffer() ;    
	AntiAlias True ;  
End Function
;--------------------------------------------------------
Function InitGround()
	;- ------------ 
	ground=CreatePlane()
	PositionEntity ground,0,-58,0 ;    
	EntityType ground, TypeWall ;   
	EntityFX ground,1 ;    ?
	;     ""
	texground=LoadTexture("Media\Textures\grass128.jpg")
	ScaleTexture texground ,100,100 ; 
	EntityTexture ground, texground ; 
	
End Function
;--------------------------------------------------------
Function InitOrudie()
	;   
	stanina=LoadMesh("Media\Models\Orudie\stanina.x")
	PositionEntity stanina,0,0,0,1
	EntityShininess stanina,0.8 ;  -    
	l=CreateLight(stanina);   
	PositionEntity l,-20,100,0,0
	start=CreatePivot(stanina);      (),    
	PositionEntity start,147,18,0,0
	NameEntity start,"start"
	PositionEntity start,147,18,0
	EntityParent start,stanina
	NameEntity start,"start";   
	;      
	koleso=LoadMesh("Media\Models\Orudie\koleso.x")
	EntityShininess koleso,0.8
	PositionEntity koleso,0,0,0,1
	koleso2=LoadMesh("Media\Models\Orudie\koleso2.x")
	EntityShininess koleso2,0.8
	PositionEntity koleso2,0,0,0,1
	EntityParent koleso2, koleso,1
	;   - 
	korobka=LoadMesh("Media\Models\Yadro\korobka.x")
	PositionEntity korobka,EntityX#(koleso,1)+10,-47,150
	 EntityShininess korobka,0.8
	EntityType korobka,TypeWall
	;  
	bullet_source=LoadMesh("Media\Models\Yadro\yadro.x")
        EntityShininess bullet_source,0.9
        PositionEntity bullet_source,EntityX#(korobka,1)+27,EntityY#(korobka,1)-5,EntityZ#(korobka,1)-15
        EntityType bullet_source,TypeBullet
        EntityParent bullet_source,korobka


End Function
;----------------------------------------------------------
Function InitImages()
	;     
	dym=LoadSprite("Media\Textures\smoke3.jpg")
	ogon=LoadSprite("Media\Textures\fireball.bmp")
	
	XOY=LoadImage("Media\Images\XOY.bmp")
	ScaleImage XOY,2,2
	MaskImage XOY,0,0,0
	XOY2=CreateImage(400,200,1)
	
	ur_t=LoadImage("Media\Images\ur_t.png")
	ur_x_y=LoadImage("Media\Images\ur_x_y.png")
	ur_vx_vy=LoadImage("Media\Images\ur_vx_vy.png")
	ur_x_y_max=LoadImage("Media\Images\ur_x_y_max.png")
End Function
;---------------------------------------------------------
Function UpdateImages()
	
	x%=ImageWidth(logo)
	y%=ImageHeight(logo)
	DrawImage logo,ScreenWidth-x%,ScreenHeight-y%
	x=ImageWidth(XOY)
	y=ImageHeight(XOY)
	DrawImage XOY2,ScreenWidth-x+16,0
	DrawImage XOY,ScreenWidth-x,0
	
	Select  imgMode
		Case 1
			x2=ImageWidth(ur_t)
			y2=ImageHeight(ur_t)
			DrawImage ur_t,ScreenWidth-x2-15,y+10
		Case 2
			x2=ImageWidth(ur_x_y)
			y2=ImageHeight(ur_x_y)
			DrawImage ur_x_y,ScreenWidth-x2-15,y+10
		Case 3
			x2=ImageWidth(ur_vx_vy)
			y2=ImageHeight(ur_vx_vy)
			DrawImage ur_vx_vy,ScreenWidth-x2-15,y+10
		Case 4
			x2=ImageWidth(ur_x_y_max)
			y2=ImageHeight(ur_x_y_max)
			DrawImage ur_x_y_max,ScreenWidth-x2-15,y+10
	End Select
	
End Function
;----------------------------------------------------------
Function UpdateOrudie()
	;If isCam2=False
	
		;      
	ox#=MouseXSpeed()
	;    
	TurnEntity koleso,0,ox#/30,0,1
	;     -90  90 
	If EntityYaw#(koleso,1)>-90 And EntityYaw#(koleso,1)<90
		TurnEntity koleso,0,0,ox#/35,0
		TurnEntity koleso2,0,0,-2*ox#/35,0
	EndIf
	 
	If EntityYaw#(koleso,1)>90 RotateEntity koleso, EntityPitch#(koleso,1),90,EntityRoll#(koleso,1)
	If EntityYaw#(koleso,1)<-90 RotateEntity koleso, EntityPitch#(koleso,1),-90,EntityRoll#(koleso,1)
	;      
	TurnEntity stanina,0,ox#/30,0,1
	;    -90  90
	If EntityYaw#(stanina,1)>90 RotateEntity stanina, EntityPitch#(stanina,1),90,EntityRoll#(stanina,1)
	If EntityYaw#(stanina,1)<-90 RotateEntity stanina, EntityPitch#(stanina,1),-90,EntityRoll#(stanina,1)
	;     
	oy#=MouseYSpeed()
	;    
	TurnEntity stanina,0,0,oy#/60
	;    0  90
	If EntityRoll#(stanina,1)>90 RotateEntity stanina, EntityPitch#(stanina,1),EntityYaw#(stanina,1),90
	If EntityRoll#(stanina,1)<0 RotateEntity stanina, EntityPitch#(stanina,1),EntityYaw#(stanina,1),0
	;   
	Ugol=EntityRoll#(stanina,1)
	;--------     SHIFT,     -----------
	
	If KeyDown(42) Or KeyDown(54)
		RotateEntity koleso,  EntityPitch#(koleso,1),0,0
		RotateEntity koleso2, EntityPitch#(koleso2,1),0,0
		RotateEntity stanina, EntityPitch#(stanina,1),0,EntityRoll#(stanina,1)
		
	EndIf
	
	;EndIf

	;     
	MoveMouse GraphicsWidth() /2,GraphicsHeight() /2
End Function
;-----------------------------------------------------------
Function InitCameras()
		;   
		camera=CreateCamera()
		;   
		CameraRange camera,.1,500000
		;  -     ""
		CameraClsColor camera,128,128,255
		;  -  
		CameraZoom camera,1
		;    
		CameraFogColor camera,200,200,200
		;   
		CameraFogRange camera,1,100
		;    -   
		light=CreateLight(1,camera)
		;   
		LightRange light,1500
		;   
		CameraProjMode camera,1
		;     
		PositionEntity camera,-300,100,0,1
	
		; 
		RotateEntity camera,0,-90,0,1
		;EntityParent camera, koleso
		;   - pderb     3D
		listener=CreateListener(camera,1,1,1) 
		;   Blitz3D
		logo=LoadImage("Media\Images\b3dlogo_small.jpg")
		; c       
		camera2=CreateCamera()
		CameraProjMode camera2,0
		CameraRange camera2,.1,500000
		CameraClsColor camera2,128,128,255
		PositionEntity camera2,3000,100,2000,1
		;     
		PointEntity camera2,camera
End Function
;-----------------------------------------------------------
Function UpdateCameras()
	;  F1- / 
	If KeyHit(59)
		effects=Not effects
	EndIf
	
	If MouseHit(1);     
		InitBullet(); c 
		;   
		If effects=True
			;     
			InitParticles(dym,Rnd(1,3),10,10,start,Rnd(-10,10),Rnd(-5,5),Rnd(-10,10),Rnd(0.4))
			;    - ,  
			InitParticles(ogon,1,50,50,start,0,0,3,.1);
		EndIf
		;      
		EmitSound(sound, camera)
		;    
		MoveEntity stanina,-15,0,0
		;       
		EntityAlpha bullet_source,0
		UpdateBullet();     , 
		;    
		UpdateParticles();     
		RenderWorld ; 
		DrawText();  
		x%=ImageWidth(logo)
		y%=ImageHeight(logo)
		UpdateImages()
		Flip
		;Delay 10
		MoveEntity stanina,15,0,0;    
		; -     
		UpdateBullet()
		UpdateParticles() 
		Delay 10;     1/100 
		;     
		EntityAlpha bullet_source,1
		RenderWorld
		DrawText()
		UpdateImages()
		Flip
	EndIf
	
	;    
	If MouseHit(2)
		;    
		isCam2=Not(isCam2)
		If isCam2=True
			;rf;ljt     1  2  
			CameraProjMode camera,0
			CameraProjMode camera2,1
		EndIf
		If isCam2=False 
			CameraProjMode camera2,0
			CameraProjMode camera,1
		EndIf
	EndIf
	
	;-----    1/2 - /     10
	If KeyHit(2) Then Skorost=Skorost-10
	If Skorost<100 Skorost=100
	If KeyHit(3) Then Skorost=Skorost+10
	;     1 /  
	If Skorost>1000 Skorost=1000
	;-----    3/4 - /     10
	If KeyHit(4) Then Skorost=Skorost-100
	If Skorost<100 Skorost=100
	If KeyHit(5) Then Skorost=Skorost+100
	;     1 /  
	If Skorost>1500 Skorost=1500
	
	;-----    5/6 - /    1
	If KeyHit(6) Then MassBullet=MassBullet-1
	; ,   1       ()
	If MassBullet<1 MassBullet=1
	If KeyHit(7) Then MassBullet=MassBullet+1
	;  20    -  - (:-))
	If MassBullet>20 Then MassBullet=20
	
	;-----    7/8 - /    10
	If KeyHit(8) Then MassOrudie=MassOrudie-10
	If MassOrudie<100 MassBullet=100
	If KeyHit(9) Then MassOrudie=MassOrudie+10
	If MassOrudie>10000 MassOrudie=10000
	
	;-----    -  
	If KeyHit(57)
		SetBuffer ImageBuffer(XOY2)
		Cls
		SetBuffer BackBuffer()
	EndIf
	;---   TAB-   
	If KeyHit(15)
		imgMode=imgMode+1
		If imgMode>5 imgMode=1
	EndIf
	
End Function
;----------------------------------------------------------
Function InitParticles(source,count%,sx,sy,target,px#,py#,pz#,alpha#)
	;     1  count
	For i%=1 To count
		;     
		part.Part=New Part
		;     
		;  ,      
		;  -  -   ...
		part\part=CopyEntity(source,target)
		;    
		ScaleSprite part\part,sx,sy
		;  
		part\alpha=alpha#
		;     
		px2=Rnd(-px,px)
		py2=Rnd(-py,py)
		pz=Rnd(-pz,pz)
		PositionEntity part\part,px2,py2,pz2,0
		; ""   
		EntityParent part\part,0
	Next
End Function
;-----------------------------------------------------------
Function UpdateParticles()
	;       ""
	For p.Part=Each Part
		;      (-8)
		EntityParent p\part,0
		;     -  
		p\alpha=p\alpha-.002
		;   
		If p\alpha<=0
			;  
			FreeEntity p\part
			;   
			Delete p
			;   
			Return
		EndIf
		;    ""
		;    
		EntityAlpha p\part,p\alpha
		;    
		RotateSprite p\part,Rnd(0.1,2.5)
		;   ,  
		MoveEntity p\part,Rnd(-1.0,1.0),Rnd(0,4),Rnd(-1.0,1.0)
	Next
End Function
;-----------------------------------------------------------
Function InitBullet()
	;   
	p.Bullet=New Bullet
	;         
	;         
	;   start
	p\bullet=CopyEntity(bullet_source)
	;    
	EntityType p\bullet,TypeBullet
	;    
	p\px#=EntityX#(start,1)
	p\py#=EntityY#(start,1)
	p\pz#=EntityZ#(start,1)
	PositionEntity p\bullet,p\px#,p\py#,p\pz#,1
	p\ux#=EntityPitch#(stanina,1)
	p\uy#=EntityYaw#(stanina,1)
	p\uz#=EntityRoll#(stanina,1)
	RotateEntity p\bullet,p\ux,p\uy,p\uz,1
	;      
	p\time#=0
	;      
	EmitSound sound2,camera
	;  
	p\red=Rnd(10,255)
	p\green=Rnd(10,255)
	p\blue=Rnd(10,255)
End Function
;-----------------------------------------------------------
Function UpdateBullet()
	SetBuffer ImageBuffer(XOY2)
	;      
 	For b.Bullet=Each Bullet
		If b<>Null
			;  -    
			If effects=True InitParticles(ogon,1,20,20,b\bullet,0,0,3,.4);
			;      
			;      -  
			If b=Last Bullet PointEntity camera2,b\bullet
			; ,        
			col=EntityCollided(b\bullet,TypeWall)
			If col ;  
				;    
				b\time=0
				;     
				EmitSound sound,camera 
				;  -       
				If effects=True InitParticles(ogon,Rnd(5,10),Rnd(450,650),Rnd(450,650),b\bullet,Rnd(-150,150),Rnd(0,50),Rnd(-150,150),Rnd(0.1,0.2))
				;    -   
				 If b=Last Bullet PointEntity camera2,stanina
				;    
				FreeEntity b\bullet
				;    
				Delete b
				TimeBullet=0;      
			EndIf
		EndIf
		
		If b<>Null 
			If b\bullet<>0
				;     1
				b\time=b\time+1
				;     
				TimeBullet=b\time/FPS
				;    ,      
				ScaleEntity b\bullet,1+6*TimeBullet,1+6*TimeBullet,1+6*TimeBullet
				;      
				MoveEntity b\bullet ,Skorost,0,0
				PositionEntity b\bullet, EntityX#(b\bullet,1),EntityY#(b\bullet,1)-0.5*G*b\time,EntityZ#(b\bullet,1)
				ddx#=Abs(EntityX#(b\bullet,1)-EntityX#(stanina,1))
				ddz#=Abs(EntityZ#(b\bullet,1)-EntityZ#(stanina,1))
				dx#=Sqr(ddx*ddx+ddz*ddz)*0.0018*(1000/Skorost)
				dy#=Abs(EntityY#(b\bullet,1)-EntityY#(stanina,1))*0.0018*(1000/Skorost)
				Color b\red,b\green,b\blue
				Oval dx,200-dy,3,3,1
			;   
			EndIf
		EndIf
	Next
	SetBuffer BackBuffer()
End Function
;-----------------------------------------------------------
Function Podschet()
	;   , ..   
	;      
	;Dalnost=Skorost*Cos(Ugol)*TimeBullet
	Dalnost=(Skorost*Skorost*Sin(2*Ugol))/G
	;   ,   ,
	;       
	;,   
	;Skorost2=Sqr(Skorost*Skorost*Cos(Ugol)*Cos(Ugol)+(Skorost*Sin(Ugol)-G*TimeBullet*Cos(Ugol))*(Skorost*Sin(Ugol)-G*TimeBullet*Cos(Ugol)))
	;    
	Vysota=(Skorost*Skorost*Sin(Ugol)*Sin(Ugol))/(2*G)
	;     
	TimeBullet2=2*Skorost*Sin(Ugol)/G
	; -        
	Skorost3=(MassBullet*Skorost*Cos(Ugol))/MassOrudie
End Function
;----------------------------------------------------------
Function DrawText()
	;       
	SetFont font
	Color 0,0,200 ;  
	Text 10,Ceil(0.02*ScreenHeight),"   G= "+Str(G)+" / ."
	Text 10,2*Ceil(0.02*ScreenHeight),"  : "+Str(Int(Ugol))+" ."
	Text 10,3*Ceil(0.02*ScreenHeight),"  : "+Str(Skorost)+ "/ .  (  1(-10), 2 (+10), 3(-100),4(+100) )"
	Text 10,4*Ceil(0.02*ScreenHeight),"  : "+Str(MassBullet)+ " .  (  5(-1)  6(+1) )"
	Text 10,5*Ceil(0.02*ScreenHeight),"  : "+Str(MassOrudie)+ " . (  7(-10)  8(+10))"
	
	Color 255,255,255;  
	Text 10,ScreenHeight/2+Ceil(0.02*ScreenHeight),"   : "+Str(Skorost)+" /"
	Text 10,ScreenHeight/2+2*Ceil(0.02*ScreenHeight),"  : "+Str(TimeBullet2)+" "
	Text 10,ScreenHeight/2+3*Ceil(0.02*ScreenHeight),"  : "+Str(Vysota)+" "
	Text 10,ScreenHeight/2+4*Ceil(0.02*ScreenHeight),"   : "+Str(Dalnost)+" "
	Text 10,ScreenHeight/2+5*Ceil(0.02*ScreenHeight),"  : "+Str(Int(Ugol))+" "
	Text 10,ScreenHeight/2+7*Ceil(0.02*ScreenHeight),"  (  )  : -"+Str(Skorost3)+" /"
	
	vidt$=""
	If Ugol<=45 
		vidt=" : "
	Else
		vidt=" : "
	EndIf
	
	Text 10,ScreenHeight/2+9*Ceil(0.02*ScreenHeight),vidt
	
	
	;Color 230,230,130; 
	
	Text ScreenWidth-450,ScreenHeight/2+1*Ceil(0.02*ScreenHeight), "-  "
	Text ScreenWidth-450,ScreenHeight/2+2*Ceil(0.02*ScreenHeight), "-   "
	
	Text ScreenWidth-450,ScreenHeight/2+4*Ceil(0.02*ScreenHeight), " :  TAB"
	Text ScreenWidth-450,ScreenHeight/2+5*Ceil(0.02*ScreenHeight), " :  "
	Text ScreenWidth-450,ScreenHeight/2+7*Ceil(0.02*ScreenHeight), ": "+Str(effects)+"   F1"
	Text ScreenWidth-450,ScreenHeight/2+8*Ceil(0.02*ScreenHeight), " : / SHIFT"
	Text ScreenWidth-450,ScreenHeight/2+10*Ceil(0.02*ScreenHeight), ":   ESC"
	
	;   
	;           
	;Text ScreenWidth-400,ScreenHeight-100," :  "+TrisRendered()
End Function
;-----------------------------------------------------------
Function InitSound()
	;   (     )
	sound=Load3DSound("Media\Sounds\Fire.wav")
	;    
	sound2=Load3DSound("Media\Sounds\Svist.wav")
End Function
;-----------------------------------------------------------
Function EraseAll();   
	;  
	For bb.Bullet =Each Bullet
		FreeEntity bb\bullet
		Delete bb
	Next
	;  
	For p.Part =Each Part
		FreeEntity p\part
		Delete p
	Next
	;  
	ClearCollisions
	;  - 
	FreeEntity korobka
	;  
	FreeEntity koleso
	;  
	FreeEntity stanina
	;  
	FreeEntity bullet_source
	;  
	FreeEntity ground
	;     
	FreeEntity dym
	;     
	FreeEntity ogon
	;  
	FreeSound sound
	FreeSound sound2
	;    
	FreeImage logo
End Function
;-----------------------------------------------------------